#!/usr/local/bin/bash

# $@ SHOULD HOLD TWO ARGS:
# $1 =  A PARTNER HOSTNAME OR IP 
# $2 = A USERNAME

echo "EXECUTING MAILSYNC SCRIPT FOR ${2} in $HOME"

MASTER=${1}

cd /home/${2} 

MAILDIRSYNC_OPTS="-r -a md5 --backup=trashbag --rsh-sep=, --rsh=ssh,-C"
SLEEP_FOR=300
while true
do

    LOCALMD5=`gunzip < /home/${2}/lib/maildirsync.gz | md5`
    REMOTEMD5=`ssh ${MASTER} zcat /home/${2}/lib/maildirsync.gz | md5`

######################################################################################################################

    #echo "`date`: MAILDIRSYNC - SYNCHRONIZING: ############# Slave <- Master  #################"
#  sudo -u ${2} -H 
maildirsync $MAILDIRSYNC_OPTS ${MASTER}:Maildir Maildir lib/maildirsync.gz
    maildirsync $MAILDIRSYNC_OPTS Maildir ${MASTER}:Maildir lib/maildirsync.gz

######################################################################################################################
    
    #echo "`date`: MAILDIRSYNC - SYNCHRONIZING: ############# Slave ->  Master  #################"
    drsync.pl --verbose=2 --rsh=ssh --recursive  --state-file=/home/${2}/lib/.push.Maildir.drsync.bz2 Maildir ${MASTER}:    
    drsync.pl --verbose=2 --rsh=ssh --exclude=BACKUP --recursive --state-file=/home/${2}/lib/.pull.Maildir.drsync.bz2 ${MASTER}:Maildir ~

######################################################################################################################

    if [ "$LOCALMD5" = "`gunzip < /home/$2/lib/maildirsync.gz  | md5`" ] && [ "$REMOTEMD5" = "`ssh ${MASTER} zcat /home/$2/lib/maildirsync.gz | md5`" ] ;
    then
	drsync.pl --delete-excluded --verbose=2 --rsh=ssh --exclude=BACKUP --recursive --state-file=/home/${2}/lib/.pull.Maildir.drsync.bz2 ${MASTER}:Maildir ~
	exit
    else
	echo "`date`: Data changed, resyncing..."
    fi
done 2>&1 | tee -a /home/$2/lib/maildirsync-`date +%Y%m%d`.log
