#!/usr/local/bin/bash

#$@ is a list of users

GROUP=crockettusers
PROGDIR=`pwd`
MASTER=chameleon1.crockettint.com
ME=`whoami`


if [ $ME != "root" ] ; then 
echo "You must be root to run this script" 
EOS 
fi 


if [ -z $1 ] ; then
        echo 'Usage: ' $0 ' "< cat userlist.txt"'
        exit
fi


function doit  {

echo ">>>-----<STARTING CHAMAILIAN SYNC FOR USER: ${1}>-----<<<"

if [ -d /home/${1} ] ; then
                echo "HOME DIRECTORY EXISTS" 
        else
                echo "NO HOME DIRECTORY FOR USER - THERE IS A PROBLEM: ${1}"
                echo "NO HOME DIRECTORY FOR ${1} ON ${MASTER} \
                          - THERE COULD BE A PROBLEM - I CREATED IT FOR YOU - BUT YOU MAY WAN
                                 | mail -s 'No home directory for account: ${1} on ${MASTER}'"
                echo "CREATING HOME DIRECTORY"
                mkdir /home/${1}
                chown ${1} /home/${1}
                #exit ;
fi

if [ -d /home/${1}/Maildir ] ; then
	echo "LOCAL MAILDIR EXISTS"
else
	echo "NO LOCAL MAILDIR .. CREATING NEW MAILDIR NOW"
	maildirmake /home/${1}/Maildir
	chown -R ${1} /home/${1}/Maildir
fi

if (ssh ${MASTER} "ls -a /home/${1}/" 2>/dev/null | grep "Maildir" > /dev/null); then
                echo "REMOTE MAILDIR DIRECTORY EXISTS"
        else
                echo "CREATING REMOTE MAILDIR DIRECTORY"
                ssh ${MASTER} "maildirmake /home/${1}/Maildir" 
                ssh ${MASTER} "chown -R ${1}:${GROUP} /home/${1}/Maildir"
fi


if [ -d /home/${1}/lib ] ; then
        echo "LOCAL LIB DIRECTORY EXISTS"
else
        echo "CREATING LOCAL LIB DIRECTORY"
        mkdir /home/${1}/lib
	chown ${1} /home/${1}/lib  
fi

if (ssh ${MASTER} "ls -a /home/${1}/" 2>/dev/null | grep "lib" > /dev/null); then
                echo "REMOTE LIB DIRECTORY EXISTS"
        else
                echo "CREATING REMOTE LIB DIRECTORY"
                ssh ${MASTER} "mkdir /home/${1}/lib" ;
                ssh ${MASTER} "chown ${1} /home/${1}/lib"
fi



if [ -d /home/${1}/.ssh ] ; then
	echo "LOCAL .SSH DIRECTORY EXISTS"
else
	echo "CREATING LOCAL .SSH DIRECTORY"
	mkdir /home/${1}/.ssh
	chown ${1} /home/${1}/.ssh
fi

#MAY CHANGE TO USE ROOTS
if [ -f /home/${1}/.ssh/id_rsa.pub ] ; then
        echo "USER ${1} HAS A LOCAL PUBLIC KEY"
else                               
        echo "CREATING LOCAL PUBLIC KEY FOR USER: ${1}"
        sudo -u ${1} ssh-keygen -t rsa -q -N "" -f /home/${1}/.ssh/id_rsa
	chown ${1}:${GROUP} /home/${1}/.ssh/id_rsa*
	scp /home/${1}/.ssh/id_rsa.pub ${MASTER}:/home/${1}/.ssh/authorized_keys
        echo "`whoami `-------------"
        ssh ${MASTER} "chown ${1} /home/${1}/.ssh/authorized_keys"
        ssh ${MASTER} "chmod 755 /home/${1}/.ssh/authorized_keys"
fi              

if (ssh ${MASTER} "ls -a /home/${1}/" 2>/dev/null | grep ".ssh" > /dev/null); then 
                echo "REMOTE .SSH DIRECTORY EXISTS"
        else
		echo "CREATING REMOTE .SSH DIRECTORY"
                ssh ${MASTER} "mkdir /home/${1}/.ssh" ;
		ssh ${MASTER} "chown ${1} /home/${1}/.ssh ; chmod 755 /home/${1}/.ssh"
fi


if (ssh ${MASTER} "ls /home/${1}/.ssh/authorized_keys" 2>/dev/null | grep "authorized_keys" > /dev/null) ; then
                echo "REMOTE AUTHORIZED_KEYS EXISTS"
		echo "MASTER SERVER IS ${MASTER}"

        else
                echo "COPYING LOCAL PUBLIC RSA KEY TO MASTER"
		echo "`whoami` -------------"
		scp /home/${1}/.ssh/id_rsa.pub ${MASTER}:/home/${1}/.ssh/authorized_keys
		echo "`whoami `-------------"
		ssh ${MASTER} "chown ${1} /home/${1}/.ssh/authorized_keys"
		ssh ${MASTER} "chmod 755 /home/${1}/.ssh/authorized_keys"

fi	

sudo -u $1 -H  $PROGDIR/do_ms.sh ${MASTER} ${1}

	
	#FUNCTION END
}

while true ; do
	for i in $@ ; do        	
		doit $i     
	done
done	
